
/*

    implementation of nightview http server clasess

    $Id: http.cpp,v 1.3 2007-08-28 18:57:59 hroch Exp $

*/


#include "http.h"
//#include <stdexcept>
#include <cstring>
#include <unistd.h>

#ifdef DEBUG
#include <iostream>
#endif

using namespace std;


void HttpServer::Request(HttpProtocol& http)
{
  string line;

  line = ReadLine();
  http.Init(line);

  while ( http.Options() ) {
    line = ReadLine();
    http.AddOption(line);

#ifdef DEBUG
    cout << line << endl;
#endif
  }

  if( http.PostData() ) {
    int n = http.ParamSize();
    const char *a = ReadData(n);
    char *b = new char[n+1];
    memcpy(b,a,n);
    b[n] = '\0';
    line = b;
    http.SetParam(line);
    delete[] b;
  }

}

void HttpServer::Response(HttpProtocol& http)
{
  string line;

  http.CheckOptions();

  Html h;
  int size = 0;
  const char *data = "";
  if( http.WriteBody() ) {
    h.Init(http.Status(),http.Method(),http.Resource(),http.Parameters(),
	   ServerAddress(),Chroot());
    http.SetContentType(h.ContentType());
    http.SetContentSize(h.ContentSize());
    http.SetStatus(h.Status());
  }

  line = http.StatusLine();
  WriteLine(line);

  if( http.WriteOptions() ) {

    line = http.ServerInfo();
    WriteLine(line);

    line = http.Date();
    WriteLine(line);

    line = http.ConnectionClose();
    WriteLine(line);
      
  }

#ifndef DEBUG
  line = http.ReqAuth();
  if( line != "" )
    WriteLine(line);
#endif

  if( http.WriteBody() ) {
    
    //Html h;
    /*
    Html h(http.Method(),http.Resource(),http.Parameters());
    int size = h.ContentSize();
    const char *data = h.Data();
    
    http.SetContentType(h.ContentType());
    http.SetContentSize(h.ContentSize());
    */
    line = http.ContentType();
    WriteLine(line);
    
    line = http.ContentSize();
    WriteLine(line);

    WriteLine("");

    size = h.ContentSize();
    data = h.Data();
    WriteData(size,data);
  }
  else
    WriteLine("");


  //  if( http.WriteBody() ) {
    /*
    char *d = http.Data();
    int size = http.Size();
    WriteData(size,d);
    */
  //}

}

void HttpServer::Process(HttpProtocol& http)
{
  /*
  if( http.CheckOptions() ) {

    string method = http.Method();
    string resource = http.Resource();
    string params = http.Parameters();

    if( http.WriteBody() ) {

      //Html h(method,resource,params);
      Html h;
      http.Body(h);
      http.SetContentType(h.ContentType());
      http.SetContentSize(h.ContentSize());
    }
  }
  */
  /*
    if( method == "GET" && resource == "/" ) {
      Html h = Static(h,resource);


    CGIServ cgi;
    if( cgi.Init(method,resource,params,ServerAddress()) && 
	(int n = cgi.DataSize()) > 0 ) {
      
      //const char *a = cgi.Data();
      //delete[] body;
      //body = new char[size];
      //memcpy(body,a,size);
      //content = cgi.ContentType();
      
      http.CreateBody(cgi.ContentType(),cgi.DataSize(),cgi.Data());
    }
  else {
    status = 500;
    writeb = false;
    writeopt = false;
    return;
  }

  */

  //  http.Process();  
}

void HttpServer::Listen(void)
{
  string line;

  while( true ) {
    Accept();
    HttpProtocol http(auth);
    Request(http);
    Process(http);
    Response(http);
    Close();
  }

}

/*
void HttpServer::Killme(bool *k)
{
  kill = k;
}
*/
bool HttpServer::NonStop(void)
{
  return(true);
  /*
  if( kill ) {
    cout << *kill << endl;
    return(!*kill);
  }
  else
    return(true);
  */
}

/*
void HttpServer::MaterializeBody(Html body)
{
  if( body.ContentType() == 0 ) {

    int size = body.ContentSize();
    char *data = new char[size];
    int n = 0;
  
    for(vector<string>::iterator l = body.begin(); l!= body.end();l++) {
      memcpy(data+n,l->data(),l->size());
      n += l->size();
    }
    WriteData(size,data);
    delete[] data;
  }

}
*/
