
/*

  headers for ccdcommon

  $Id: ccdcommon.h,v 1.8 2008-08-15 20:42:30 hroch Exp $

*/

extern CCD *ccd_new(char *address);
extern void ccd_free(CCD *ccd);
extern char *ccd_get_address(CCD *ccd);
extern int ccd_set_on(CCD *ccd, int on);
extern int ccd_get_on(CCD *ccd);
extern CCDINFO *ccd_new_info(CCD *ccd, int i, char *name, char *firmware, 
			     char *serial, int width, int height, int offset, 
			     int adrange, int abg, float pixwidth, 
			     float pixheight, float gain, int, double, double, 
			     int nbad, int bad[]);
extern CCDREADOUT *ccd_new_readout(CCDINFO *ccdinfo, int i, int mode,int width,
				  int height,float gain,float pixw,float pixh);
extern int ccd_info_all(CCD *);
extern int ccd_nchiplist(CCD *);
extern char *ccd_get_firmware(CCD *, int);
extern char *ccd_get_cameraname(CCD *, int);
extern char *ccd_get_serial(CCD *, int);
extern int ccd_get_abgtype(CCD *, int);
extern int ccd_get_bitpix(CCD *, int);
extern int ccd_get_adrange(CCD *, int);
extern int ccd_get_bias(CCD *, int);
extern int ccd_get_nbadcol(CCD *, int);
extern int ccd_get_badcol(CCD *, int, int);
extern int ccd_get_nreadout(CCD *, int);
extern int ccd_get_readout_mode(CCD *, int, int);
extern int ccd_get_readout_width(CCD *, int, int);
extern int ccd_get_readout_height(CCD *, int, int);
extern float ccd_get_readout_pixsize(CCD *, int, int);
extern float ccd_get_readout_piysize(CCD *, int, int);
extern float ccd_get_readout_gain(CCD *, int, int);
extern void ccd_free_info(CCD *ccd, int i);
extern void ccd_free_readout(CCD *ccd, int i, int j);
extern int ccdinfo_set_name(CCD *ccd, int i,char *name);
extern int ccdinfo_set_size(CCD *ccd, int i, int width, int height);
extern int ccdinfo_set_pixsize(CCD *ccd, int i, int width, int height);
extern int ccdinfo_set_gain(CCD *ccd, int i, float gain);
extern char *ccdinfo_get_name(CCD *ccd, int i);
extern int ccdinfo_get_size_width(CCD *ccd, int i);
extern int ccdinfo_get_size_height(CCD *ccd, int i);
extern float ccdinfo_get_size_pixwidth(CCD *ccd, int i);
extern float ccdinfo_get_size_pixheight(CCD *ccd, int i);
extern float ccdinfo_get_gain(CCD *ccd, int i);
extern double ccdinfo_get_minexp(CCD *ccd, int i);
extern double ccd_get_minexp(CCD *ccd, int i);
extern double ccdinfo_get_maxexp(CCD *ccd, int i);
extern double ccd_get_maxexp(CCD *ccd, int i);
extern int ccd_set_tempccd(CCD *ccd, float temp);
extern int ccd_set_tempair(CCD *ccd, float temp);
extern int ccd_set_exptime(CCD *ccd, double);
extern float ccd_get_tempccd(CCD *ccd);
extern float ccd_get_tempair(CCD *ccd);
extern float ccd_get_regpower(CCD *ccd);
extern int ccd_get_fan(CCD *ccd);
extern int ccd_set_fan(CCD *ccd, int fan);
extern int ccd_set_nfilters(CCD *ccd, int nfilters);
extern int ccd_get_nfilters(CCD *ccd);
extern int ccd_set_filters(CCD *ccd, int,int n, char *fl[]);
extern char *ccd_get_filter(CCD *ccd, int i);
extern char *ccd_get_cfilter(CCD *ccd);
extern char *ccd_get_cfilter(CCD *ccd);
extern char *ccd_filter_list(CCD *ccd);
extern int ccd_set_filterwheel(CCD *ccd,int);
extern int ccd_get_filterwheel(CCD *ccd);
extern int ccd_set_site(CCD *ccd, char *name, double lg, double ln, double al);
extern char *ccd_get_site_name(CCD *ccd);
extern double ccd_get_site_long(CCD *ccd);
extern double ccd_get_site_lat(CCD *ccd);
extern double ccd_get_site_alt(CCD *ccd);
extern int ccd_set_dec(CCD *ccd, double dec);
extern double ccd_get_dec(CCD *ccd);
extern double ccd_get_ra(CCD *ccd);
extern int ccd_set_ra(CCD *ccd, double ra);
extern double ccd_get_exptime(CCD *ccd);
extern int ccd_set_extime(CCD *ccd, double exptime);
extern char *ccd_get_object(CCD *ccd);
extern int ccd_set_object(CCD *ccd, char *name);
extern int ccd_set_observer(CCD *ccd, char *name);
extern char *ccd_get_observer(CCD *ccd);
extern char *ccd_get_datetime(CCD *ccd);
extern int ccd_set_datetime(CCD *ccd, char *name);
extern char *ccd_get_fitsname(CCD *ccd);
extern int ccd_set_fitsname(CCD *ccd, char *name);
extern int ccd_set_telescope(CCD *ccd, char *name, double);
extern int ccd_set_binnig(CCD *ccd, int bin);
extern int ccd_get_binning(CCD *ccd);
extern char *ccd_get_datetime(CCD *ccd);
extern int ccd_set_extime(CCD *ccd, double exptime);
extern int ccd_get_saturation(CCD *ccd);
extern char *ccd_get_telescope_name(CCD *ccd);
extern double ccd_get_telescope_focus(CCD *ccd);
extern void ccd_get_telescope_ra_dec(CCD *ccd, double *, double *);
extern int ccd_keep_image(CCD *ccd, int chip, int binnig, int startx, int starty, int nx, int ny, unsigned short *fitsimage, char *);
extern void systime(char *datetime);
extern void split(char *c, char *o[], int lend, char *sep);
